function [XN,YN,XS,YS]=SmothBound(F,N,SM)

    f=figure;

    F=im2bw(F,0.5); F=+F;
    h=fspecial('gaussian', [5 5], 1);
    G=imfilter(F, h,'replicate');
    SmBound = contour(G,1);  
    
    ii=find(SmBound(1,:)<1);
    [vv, jj]=max(SmBound(2,ii));
    
    bg=ii(jj)+1;
    en=ii(jj)+vv;
    
    XS=SmBound(1,bg:en); YS=SmBound(2,bg:en); %NS=SmBound(2,1);

    DS=sqrt((XS(2:end)-XS(1:(end-1))).^2+(YS(2:end)-YS(1:(end-1))).^2);
    CS=[0 cumsum(DS)];
    r=sum(DS)/N;

    XN=zeros(1,N); YN=zeros(1,N);
    RD=0; XN(1)=XS(1); YN(1)=YS(1);
    for i=1:(N-1)    
        RD=RD+r;
        [vi, mi]=max(CS(CS<=RD));
        w=RD-vi;
        XN(i+1)=XS(mi)+(XS(mi+1)-XS(mi))*w/DS(mi);
        YN(i+1)=YS(mi)+(YS(mi+1)-YS(mi))*w/DS(mi);    
    end

    XN=fliplr(XN); YN=fliplr(YN);
    close(f);



    
    


    %{
    N=length(X);
    XB=X; YB=Y;   
    XN=X; YN=Y;
    MB=[max(X)+10 min(X)-10 max(Y)+10 min(Y)-10];
    MD=zeros(1,M);

    j=1; h=1;
    while j<M && h>TH
        for i=1:N    
            if i==N 
                xm=(X(i-1)+X(1))/2;
                ym=(Y(i-1)+Y(1))/2;
            elseif i==1;     
                xm=(X(N)+X(i+1))/2;
                ym=(Y(N)+Y(i+1))/2;
            else        
                xm=(X(i-1)+X(i+1))/2;
                ym=(Y(i-1)+Y(i+1))/2;
            end  

            db = DistToBound(xm,ym,XB,YB,MB);

            if db<0.5
                XN(i)=xm; YN(i)=ym;
            else
                XN(i)=X(i); YN(i)=Y(i);
            end       
        end

        DD=sqrt((X(2:end)-X(1:(end-1))).^2+(Y(2:end)-Y(1:(end-1))).^2);
        MD(j)=mean(DD);
        if j>1
            h=abs(MD(j)-MD(j-1));
        else
            h=1;
        end
        j=j+1;    
        X=XN; Y=YN; 
    end
    XF=X; YF=Y; ST=j-1; MF=MD(1:ST);
    %}