function lstfiles(path,name,expr,handles)

    
    if isempty(name)
        fullname=path;
    else
        fullname=[path '/' name];
    end
    f=dir(fullname);
    n=size(f,1);
    
    for i=1:n
        if f(i).isdir
            if ~strcmp('.',f(i).name) && ~strcmp('..',f(i).name)
                lstfiles(fullname,f(i).name,expr,handles);
            end
            
        else
            
            str=regexp(f(i).name,expr,'match');            
            if strcmp(f(i).name,str{1})
                
                file=[fullname '/' f(i).name];
                set(handles.text_file_name,'String',['Processing: ' f(i).name]);
                disp('File matching the pattern:');
                disp(file);
                disp(' ');
                LoadMasks(handles,file);
                try
                    [status1,message1,~]=movefile([cd '/temp.mat'],[file(1:end-4) '.mat']);
                    if ~status1
                        message1
                    end
                    
                    [status2,message2,messageid2]=movefile([cd '/text_temp.txt'],[file(1:end-4) '.txt']);
                    if ~status2
                        message2
                    end
                    
                catch                    
                    warndlg({'[lstfiles]You must complete the processing step before saving'});
                    return;
                end
                sliderVal2 = get(handles.slider2,'Value');
                sliderVal3 = get(handles.slider3,'Value');
                x_scale = get(handles.edit1,'String');
                t_scale = get(handles.edit2,'String');
                sm_window = get(handles.Fit_Window_Tag,'String');
                time_lag = get(handles.Time_Lag_Tag,'String');
                index = handles.Index;
                sl_index = handles.slider_index;
                CRvalues = [handles.CrB,handles.CrP1,handles.CrK,handles.CrP,handles.CrU,handles.CrP5,handles.CrP6];
                               
                save([file(1:end - 4) 'options.mat'],'sliderVal2','sliderVal3','x_scale','t_scale','sm_window','time_lag','index','sl_index','CRvalues');
                    
            end
        end
    end
            